package com.matritel.resttodo.service;

import com.matritel.resttodo.model.Priority;
import com.matritel.resttodo.model.TodoDto;
import com.matritel.resttodo.repository.ToDoRepository;
import com.matritel.resttodo.repository.entity.TodoEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

//sub-annotation for @Component
@Service
public class TodoService {
    @Autowired
    private ToDoRepository repository;

    public TodoDto create(TodoDto todoInput) {
        //We need to post a DTO object as a response when a user create a request (due to the method signature as well)
        //But we just be able to save DAO object into the Database that's why use the builder first
        //And we also need a second convert (builder) to get DTO object to be able to return it

        // first we pass the fields from a TodoDto object to a new TodoEntity object plus add the createdAt field and the ID is autoGenerated because of the annotation in the ToDoEntity class
        TodoEntity toSave = buildToEntity(todoInput);

        // the save method (implements by the CrudRepository) save the TodoEntity into the database and returns a TodoEntity, that's why we need to create a new Entity object for it
        // second we pass the fields from a TodoEntity object (= 'saved') to a new TodoDto object with the new id and createdAt field generated before in the toEntity (because it's the responsibility of repository layer)
        TodoEntity saved = repository.save(toSave);


        //To convert different objects' state to another we use 'builder' methods(ex: return).
        // To be able to use these methods wee need to add @Builder annotation for classes what we would like to use
        return toDto(saved);
    }

    public TodoDto put(TodoDto todoInput, String id) {
        Optional<TodoEntity> entityFromDb = repository.findById(id);
        TodoEntity todoEntity;
        if (entityFromDb.isPresent()) {
            todoEntity = entityFromDb.get();
            todoEntity.setDescription(todoInput.getDescription());
            todoEntity.setPersonInCharge(todoInput.getPersonInCharge());
            todoEntity.setPriority(todoInput.getPriority());
        } else {
            todoEntity = buildToEntity(todoInput);
            todoEntity.setId(id);
        }
        repository.save(todoEntity);
        return toDto(todoEntity);
    }

    public List<TodoDto> findAll() {
        List<TodoDto> todoDtoList = new ArrayList<>();
        for (TodoEntity entity : repository.findAll()) {
            todoDtoList.add(toDto(entity));
        }
        return todoDtoList;
    }

    public List<TodoDto> findAllByPriority(Priority priority) {
        List<TodoDto> todoDtoList = new ArrayList<>();
        for (TodoEntity entity : repository.findAllByPriority(priority)) {
            todoDtoList.add(toDto(entity));
        }
        return todoDtoList;
    }

    public List<TodoDto> findAllByPIC(String personInCharge) {
        List<TodoDto> todoDtoList = new ArrayList<>();
        for (TodoEntity entity : repository.findAll()) {
            if (entity.getPersonInCharge().equals(personInCharge)) {
                todoDtoList.add(toDto(entity));
            }
        }
        return todoDtoList;
    }

    public Optional<TodoDto> findById(String id) {
        Optional<TodoEntity> optionalTodoEntity = repository.findById(id);
        if (optionalTodoEntity.isPresent()) {
            return Optional.of(toDto(optionalTodoEntity.get()));
        } else {
            return Optional.empty();
        }
    }

    public void deleteById(String id) {
        repository.deleteById(id);
    }

    private TodoEntity buildToEntity(TodoDto todoInput) {
        return TodoEntity.builder()
                .description(todoInput.getDescription())
                .personInCharge(todoInput.getPersonInCharge())
                .priority(todoInput.getPriority())
                .createdAt(LocalDate.now())
                .build();
    }

    private TodoDto toDto(TodoEntity saved) {
        return TodoDto.builder()
                .id(saved.getId())
                .description(saved.getDescription())
                .personInCharge(saved.getPersonInCharge())
                .priority(saved.getPriority())
                .createdAt(saved.getCreatedAt())
                .build();
    }
}
